/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.UIElement;
import javax.swing.JColorChooser;

public class ColorChooser extends Widget {
    private attribute jcolorchooser:<<javax.swing.JColorChooser>>;
    public attribute showDialog: Boolean;
    public attribute action: function(c:Color);
    public attribute title: String;
    public attribute owner: UIElement?;
    public attribute initialColor: Color;
    public attribute selectedColor: Color;
    operation show();
}

attribute ColorChooser.initialColor = white;

operation ColorChooser.createComponent() {
    jcolorchooser = new JColorChooser(initialColor.getColor());
    var self = this;
    jcolorchooser.getSelectionModel().addChangeListener(new <<javax.swing.event.ChangeListener>>() {
                                                            operation stateChanged(e) {
                                                                self.selectedColor = fromAWTColor(self.jcolorchooser.getColor());
                                                            }
                                                        });
    return jcolorchooser;
}

trigger on ColorChooser.showDialog = value {
    if (value) {
        this.show();
    }
}

operation ColorChooser.show() {
    var result = <<javax.swing.JColorChooser>>.showDialog(owner.getWindow(), 
                                                          title,
                                                          initialColor.getColor());
    visible = false;
    if (result <> null) {
        (this.action)(fromAWTColor:Color(result));
    }
}
