/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.ScrollableWidget;
import javafx.ui.ContentType;

public class EditorPane extends ScrollableWidget {
    private attribute inUpdate:Boolean;
    private attribute documentListener:<<javax.swing.event.DocumentListener>>;
    private attribute jeditorpane: <<javax.swing.JEditorPane>>;
    public attribute editable: Boolean?;
    public attribute text: String;
    public attribute honorDisplayProperties: Boolean;
    public attribute margin:Insets?;
    public attribute contentType: ContentType?;
    public attribute editorKit: <<javax.swing.text.EditorKit>>?;
}

trigger on (EditorPane.editable = value) {
    jeditorpane.setEditable(value);
}

trigger on (EditorPane.editorKit = value) {
    jeditorpane.setEditorKit(value);
}

trigger on (EditorPane.contentType = value) {
    jeditorpane.setContentType(value.mimeType);
}

trigger on (EditorPane.margin = value) {
    jeditorpane.setMargin(value.awtinsets);
}

trigger on (EditorPane.honorDisplayProperties = value) {
    jeditorpane.putClientProperty(jeditorpane.HONOR_DISPLAY_PROPERTIES,
                                  value);
}

trigger on (new EditorPane) {
    editable = true;
    jeditorpane = new <<javax.swing.JEditorPane>>;
    jeditorpane.setOpaque(false);
    jeditorpane.getDocument().putProperty("imageCache",
                                          context:<<net.java.javafx.ui.UIContext>>.getImageCache());
    editable = true;
    var self = this;
    documentListener = new <<javax.swing.event.DocumentListener>>() {
        operation insertUpdate(e:<<javax.swing.event.DocumentEvent>>) {
            self.inUpdate = true;
            self.text = self.jeditorpane.getText();
            self.inUpdate = false;
        }
        operation removeUpdate(e:<<javax.swing.event.DocumentEvent>>) {
            self.inUpdate = true;
            self.text = self.jeditorpane.getText();
            self.inUpdate = false;
        }
        operation changedUpdate(e:<<javax.swing.event.DocumentEvent>>) {
            self.inUpdate = true;
            self.text = self.jeditorpane.getText();
            self.inUpdate = false;
        }
    };
    jeditorpane.getDocument().addDocumentListener(documentListener);
}

trigger on EditorPane.text = value {
    if (not inUpdate) {
       jeditorpane.setText(value);
    }
}


operation EditorPane.createView():<<javax.swing.JComponent>> {
    jeditorpane.<<select>>(0,0);
    return jeditorpane;
}

