/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;

public class GridCell {
    protected attribute constraint: <<java.awt.GridBagConstraints>>;
    public attribute insets: Insets?;
    public attribute anchor: Anchor;
    public attribute gridwidth: Number;
    public attribute gridheight: Number;
    public attribute gridx: Number;
    public attribute gridy: Number;
    public attribute fill: Fill;
    public attribute weightx: Number;
    public attribute weighty: Number;
    public attribute ipadx: Number;
    public attribute ipady: Number;
    public attribute content: Widget;
}

trigger on (new GridCell) {
    anchor = CENTER:Anchor;
    fill = NONE:Fill;
    gridx = <<java.awt.GridBagConstraints>>.RELATIVE;
    gridy = <<java.awt.GridBagConstraints>>.RELATIVE;
    gridwidth = 1;
    gridheight = 1;
    weightx = 0.0;
    weighty = 0.0;
    ipadx = 0;
    ipady = 0;
    constraint = new <<java.awt.GridBagConstraints>>();
}

trigger on (GridCell.anchor = value) {
    constraint.anchor = value.id;
}

trigger on (GridCell.fill = value) {
    constraint.fill = value.id;
}

trigger on (GridCell.gridx = value) {
    constraint.gridx = value;
}

trigger on (GridCell.gridy = value) {
    constraint.gridy = value;
}

trigger on (GridCell.gridheight = value) {
    constraint.gridheight = value;
}

trigger on (GridCell.gridwidth = value) {
    constraint.gridwidth = value;
}

trigger on (GridCell.weightx = value) {
    constraint.weightx = value;
}

trigger on (GridCell.weighty = value) {
    constraint.weighty = value;
}

trigger on (GridCell.ipadx = value) {
    constraint.ipadx = value;
}

trigger on (GridCell.ipady = value) {
    constraint.ipady = value;
}

trigger on (GridCell.insets = value) {
    constraint.insets = value.awtinsets;
}
