/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Spring;
import javafx.ui.Row;
import javafx.ui.Column;

/** 
 * Abstract base class for elements that participate in Group layout.
 */

public class GroupElement {
    /** Optional horizontal spring that determines the horizontal resizing behavior of this element when contained in a GroupLayout.*/
    public attribute horizontal: Spring?;
    /** Optional vertical spring that determines the vertical resizing behavior of this element when contained in a GroupLayout.*/
    public attribute vertical: Spring?;
    /** The row this element is contained in within a GroupLayout. */
    public attribute row: Row?;
    /** The column this element is contained in within a GroupLayout. */
    public attribute column: Column?;
    ...
}
