/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Keyboard;
import javafx.ui.KeyModifier;

KEYBOARD:Keyboard = new Keyboard;

public class KeyStroke {
    attribute description: String;
    attribute id: Number;
    attribute keyChar: String?;
}

trigger on KeyStroke.id = value {
    KEYBOARD:Keyboard.keyMap.put(id, this);
    description = <<javax.swing.KeyStroke>>.getKeyStroke(id, 0).toString();
}

/*
ALT_DOWN:KeyStroke = KeyStroke {id: <<java.awt.event.InputEvent>>.ALT_DOWN_MASK};
*/
ENTER:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ENTER };
BACK_SPACE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_BACK_SPACE };
TAB:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_TAB };
CANCEL:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CANCEL };
CLEAR:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CLEAR };
SHIFT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_SHIFT };
CONTROL:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CONTROL };
ALT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ALT };
PAUSE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_PAUSE };
CAPS_LOCK:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CAPS_LOCK };
ESCAPE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ESCAPE };
SPACE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_SPACE };
PAGE_DOWN:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_PAGE_DOWN };
PAGE_UP:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_PAGE_UP };
END:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_END };
HOME:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_HOME };

    /**
     * Constant for the non-numpad <b>left</b> arrow key.
     * @see #VK_KP_LEFT
     */
LEFT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_LEFT };

    /**
     * Constant for the non-numpad <b>up</b> arrow key.
     * @see #VK_KP_UP
     */
UP:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_UP };

    /**
     * Constant for the non-numpad <b>right</b> arrow key.
     * @see #VK_KP_RIGHT
     */
RIGHT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_RIGHT };

    /**
     * Constant for the non-numpad <b>down</b> arrow key.
     * @see #VK_KP_DOWN
     */
DOWN:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_DOWN };

    /**
     * Constant for the comma key, ","
     */
COMMA:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_COMMA };

    /**
     * Constant for the minus key, "-"
     * @since 1.2
     */
MINUS:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_MINUS };

    /**
     * Constant for the period key, "."
     */
PERIOD:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_PERIOD };

    /**
     * Constant for the forward slash key, "/"
     */
SLASH:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_SLASH };

    /** VK_0 thru VK_9 are the same as ASCII '0' thru '9' (0x30 - 0x39) */
_0:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_0 };
_1:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_1 };
_2:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_2 };
_3:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_3 };
_4:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_4 };
_5:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_5 };
_6:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_6 };
_7:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_7 };
_8:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_8 };
_9:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_9 };

    /**
     * Constant for the semicolon key, ";"
     */
SEMICOLON:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_SEMICOLON };

    /**
     * Constant for the equals key, "="
     */
EQUALS:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_EQUALS };

    /** VK_A thru VK_Z are the same as ASCII 'A' thru 'Z' (0x41 - 0x5A) */
A:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_A, keyChar:"a" };
B:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_B, keyChar:"b"  };
C:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_C, keyChar:"c" };
D:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_D, keyChar:"d" };
E:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_E , keyChar:"e"};
F:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F, keyChar:"f" };
G:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_G , keyChar:"g"};
H:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_H, keyChar:"h" };
I:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_I , keyChar:"i"};
J:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_J , keyChar:"j"};
K:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_K , keyChar:"k"};
L:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_L , keyChar:"l"};
M:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_M , keyChar:"m"};
N:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_N , keyChar:"n"};
O:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_O , keyChar:"o"};
P:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_P , keyChar:"p"};
Q:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_Q , keyChar:"q"};
R:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_R , keyChar:"r"};
S:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_S , keyChar:"s"};
T:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_T , keyChar:"t"};
U:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_U , keyChar:"u"};
V:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_V , keyChar:"v"};
W:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_W , keyChar:"w"};
X:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_X , keyChar:"x"};
Y:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_Y , keyChar:"y"};
Z:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_Z , keyChar:"z"};

    /**
     * Constant for the open bracket key, "["
     */
OPEN_BRACKET:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_OPEN_BRACKET };

    /**
     * Constant for the back slash key, "\"
     */
BACK_SLASH:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_BACK_SLASH };

    /**
     * Constant for the close bracket key, "]"
     */
CLOSE_BRACKET:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CLOSE_BRACKET };

NUMPAD0:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD0 };
NUMPAD1:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD1 };
NUMPAD2:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD2 };
NUMPAD3:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD3 };
NUMPAD4:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD4 };
NUMPAD5:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD5 };
NUMPAD6:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD6 };
NUMPAD7:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD7 };
NUMPAD8:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD8 };
NUMPAD9:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMPAD9 };
MULTIPLY:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_MULTIPLY };
ADD:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ADD };

    /** 
     * This constant is obsolete, and is included only for backwards
     * compatibility.
     * @see #VK_SEPARATOR
     */
SEPARATER:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_SEPARATER };

    /** 
     * Constant for the Numpad Separator key. 
     * @since 1.4
     */
SEPARATOR:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_SEPARATOR };

SUBTRACT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_SUBTRACT };
DECIMAL:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_DECIMAL };
DIVIDE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_DIVIDE };
DELETE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_DELETE }; /* ASCII DEL */
NUM_LOCK:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUM_LOCK };
SCROLL_LOCK:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_SCROLL_LOCK };

    /** Constant for the F1 function key. */
F1:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F1 };

    /** Constant for the F2 function key. */
F2:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F2 };

    /** Constant for the F3 function key. */
F3:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F3 };

    /** Constant for the F4 function key. */
F4:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F4 };

    /** Constant for the F5 function key. */
F5:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F5 };

    /** Constant for the F6 function key. */
F6:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F6 };

    /** Constant for the F7 function key. */
F7:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F7 };

    /** Constant for the F8 function key. */
F8:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F8 };

    /** Constant for the F9 function key. */
F9:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F9};

    /** Constant for the F10 function key. */
F10:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F10 };

    /** Constant for the F11 function key. */
F11:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F11 };

    /** Constant for the F12 function key. */
F12:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F12 };

    /**
     * Constant for the F13 function key.
     * @since 1.2
     */
    /* F13 - F24 are used on IBM 3270 keyboard; use random range for constants. */
F13:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F3 };
 
    /**
     * Constant for the F14 function key.
     * @since 1.2
     */
F14:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F14 };
 
    /**
     * Constant for the F15 function key.
     * @since 1.2
     */
F15:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F15 };
 
    /**
     * Constant for the F16 function key.
     * @since 1.2
     */
F16:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F16 };
 
    /**
     * Constant for the F17 function key.
     * @since 1.2
     */
F17:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F17 };
 
    /**
     * Constant for the F18 function key.
     * @since 1.2
     */
F18:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F18 };
 
    /**
     * Constant for the F19 function key.
     * @since 1.2
     */
F19:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F19 };
 
    /**
     * Constant for the F20 function key.
     * @since 1.2
     */
F20:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F20 };
 
    /**
     * Constant for the F21 function key.
     * @since 1.2
     */
F21:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F21 };
 
    /**
     * Constant for the F22 function key.
     * @since 1.2
     */
F22:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F22 };
 
    /**
     * Constant for the F23 function key.
     * @since 1.2
     */
F23:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F23 };
 
    /**
     * Constant for the F24 function key.
     * @since 1.2
     */
F24:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_F24 };
 
PRINTSCREEN:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_PRINTSCREEN };
INSERT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_INSERT };
HELP:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_HELP };
META:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_META };

BACK_QUOTE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_BACK_QUOTE };
QUOTE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_QUOTE };

    /**
     * Constant for the numeric keypad <b>up</b> arrow key.
     * @see #VK_UP
     * @since 1.2
     */
KP_UP:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_KP_UP };

    /**
     * Constant for the numeric keypad <b>down</b> arrow key.
     * @see #VK_DOWN
     * @since 1.2
     */
KP_DOWN:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_KP_DOWN };

    /**
     * Constant for the numeric keypad <b>left</b> arrow key.
     * @see #VK_LEFT
     * @since 1.2
     */
KP_LEFT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_KP_LEFT };

    /**
     * Constant for the numeric keypad <b>right</b> arrow key.
     * @see #VK_RIGHT
     * @since 1.2
     */
KP_RIGHT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_KP_RIGHT };
    
    /** @since 1.2 */
AMPERSAND:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_AMPERSAND };
    /** @since 1.2 */
ASTERISK:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ASTERISK };
    /** @since 1.2 */
QUOTEDBL:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_QUOTEDBL };
    /** @since 1.2 */
LESS:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_LESS };

    /** @since 1.2 */
GREATER:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_GREATER };
    /** @since 1.2 */
BRACELEFT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_BRACELEFT };
    /** @since 1.2 */
BRACERIGHT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_BRACERIGHT };

    /**
     * Constant for the "@" key.
     * @since 1.2
     */
AT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_AT };
 
    /**
     * Constant for the ":" key.
     * @since 1.2
     */
COLON:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_COLON };
 
    /**
     * Constant for the "^" key.
     * @since 1.2
     */
CIRCUMFLEX:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CIRCUMFLEX };
 
    /**
     * Constant for the "$" key.
     * @since 1.2
     */
DOLLAR:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_DOLLAR };
 
    /**
     * Constant for the Euro currency sign key.
     * @since 1.2
     */
EURO_SIGN:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_EURO_SIGN };
 
    /**
     * Constant for the "!" key.
     * @since 1.2
     */
EXCLAMATION_MARK:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_EXCLAMATION_MARK };
 
    /**
     * Constant for the inverted exclamation mark key.
     * @since 1.2
     */
INVERTED_EXCLAMATION_MARK:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_INVERTED_EXCLAMATION_MARK };
 
    /**
     * Constant for the "(" key.
     * @since 1.2
     */
LEFT_PARENTHESIS:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_LEFT_PARENTHESIS };
 
    /**
     * Constant for the "#" key.
     * @since 1.2
     */
NUMBER_SIGN:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NUMBER_SIGN };
 
    /**
     * Constant for the "+" key.
     * @since 1.2
     */
PLUS:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_PLUS };
 
    /**
     * Constant for the ")" key.
     * @since 1.2
     */
RIGHT_PARENTHESIS:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_RIGHT_PARENTHESIS };
 
    /**
     * Constant for the "_" key.
     * @since 1.2
     */
UNDERSCORE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_UNDERSCORE };
 
    /**
     * Constant for the Microsoft Windows "Windows" key.
     * It is used for both the left and right version of the key.  
     * @see #getKeyLocation()
     * @since 1.5
     */
WINDOWS:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_WINDOWS };
 
    /**
     * Constant for the Microsoft Windows Context Menu key.
     * @since 1.5
     */
CONTEXT_MENU:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CONTEXT_MENU };
 
    /* for input method support on Asian Keyboards */

    /* not clear what this means - listed in Microsoft Windows API */
FINAL:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_FINAL };
    
    /** Constant for the Convert function key. */
    /* Japanese PC 106 keyboard, Japanese Solaris keyboard: henkan */
CONVERT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CONVERT };

    /** Constant for the Don't Convert function key. */
    /* Japanese PC 106 keyboard: muhenkan */
NONCONVERT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_NONCONVERT };
    
    /** Constant for the Accept or Commit function key. */
    /* Japanese Solaris keyboard: kakutei */
ACCEPT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ACCEPT };

    /* not clear what this means - listed in Microsoft Windows API */
MODECHANGE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_MODECHANGE };

    /* replaced by VK_KANA_LOCK for Microsoft Windows and Solaris; 
       might still be used on other platforms */
KANA:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_KANA };

    /* replaced by VK_INPUT_METHOD_ON_OFF for Microsoft Windows and Solaris; 
       might still be used for other platforms */
KANJI:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_KANJI };

    /**
     * Constant for the Alphanumeric function key.
     * @since 1.2
     */
    /* Japanese PC 106 keyboard: eisuu */
ALPHANUMERIC:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ALPHANUMERIC };
 
    /**
     * Constant for the Katakana function key.
     * @since 1.2
     */
    /* Japanese PC 106 keyboard: katakana */
KATAKANA:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_KATAKANA };
 
    /**
     * Constant for the Hiragana function key.
     * @since 1.2
     */
    /* Japanese PC 106 keyboard: hiragana */
HIRAGANA:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_HIRAGANA };
 
    /**
     * Constant for the Full-Width Characters function key.
     * @since 1.2
     */
    /* Japanese PC 106 keyboard: zenkaku */
FULL_WIDTH:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_FULL_WIDTH };
 
    /**
     * Constant for the Half-Width Characters function key.
     * @since 1.2
     */
    /* Japanese PC 106 keyboard: hankaku */
HALF_WIDTH:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_HALF_WIDTH };
 
    /**
     * Constant for the Roman Characters function key.
     * @since 1.2
     */
    /* Japanese PC 106 keyboard: roumaji */
ROMAN_CHARACTERS:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ROMAN_CHARACTERS };
 
    /**
     * Constant for the All Candidates function key.
     * @since 1.2
     */
    /* Japanese PC 106 keyboard - VK_CONVERT + ALT: zenkouho */
ALL_CANDIDATES:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ALL_CANDIDATES };
 
    /**
     * Constant for the Previous Candidate function key.
     * @since 1.2
     */
    /* Japanese PC 106 keyboard - VK_CONVERT + SHIFT: maekouho */
PREVIOUS_CANDIDATE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_PREVIOUS_CANDIDATE };
 
    /**
     * Constant for the Code Input function key.
     * @since 1.2
     */
    /* Japanese PC 106 keyboard - VK_ALPHANUMERIC + ALT: kanji bangou */
CODE_INPUT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CODE_INPUT };
 
    /**
     * Constant for the Japanese-Katakana function key.
     * This key switches to a Japanese input method and selects its Katakana input mode.
     * @since 1.2
     */
    /* Japanese Macintosh keyboard - VK_JAPANESE_HIRAGANA + SHIFT */
JAPANESE_KATAKANA:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_JAPANESE_KATAKANA };
 
    /**
     * Constant for the Japanese-Hiragana function key.
     * This key switches to a Japanese input method and selects its Hiragana input mode.
     * @since 1.2
     */
    /* Japanese Macintosh keyboard */
JAPANESE_HIRAGANA:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_JAPANESE_HIRAGANA };
 
    /**
     * Constant for the Japanese-Roman function key.
     * This key switches to a Japanese input method and selects its Roman-Direct input mode.
     * @since 1.2
     */
    /* Japanese Macintosh keyboard */
JAPANESE_ROMAN:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_JAPANESE_ROMAN };

    /**
     * Constant for the locking Kana function key.
     * This key locks the keyboard into a Kana layout.
     * @since 1.3
     */
    /* Japanese PC 106 keyboard with special Windows driver - eisuu + Control; Japanese Solaris keyboard: kana */
KANA_LOCK:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_KANA_LOCK };

    /**
     * Constant for the input method on/off key.
     * @since 1.3
     */
    /* Japanese PC 106 keyboard: kanji. Japanese Solaris keyboard: nihongo */
INPUT_METHOD_ON_OFF:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_INPUT_METHOD_ON_OFF };

    /* for Sun keyboards */
    /** @since 1.2 */
CUT:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_CUT };
    /** @since 1.2 */
COPY:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_COPY };
    /** @since 1.2 */
PASTE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_PASTE };
    /** @since 1.2 */
UNDO:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_UNDO };
    /** @since 1.2 */
AGAIN:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_AGAIN };
    /** @since 1.2 */
FIND:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_FIND };
    /** @since 1.2 */
PROPS:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_PROPS };
    /** @since 1.2 */
STOP:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_STOP };
    
    /**
     * Constant for the Compose function key.
     * @since 1.2
     */
COMPOSE:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_COMPOSE };
 
    /**
     * Constant for the AltGraph function key.
     * @since 1.2
     */
ALT_GRAPH:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_ALT_GRAPH };

    /**
     * Constant for the Begin key.
     * @since 1.5
     */
BEGIN:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_BEGIN };

    /**
     * This value is used to indicate that the keyCode is unknown.
     * KEY_TYPED events do not have a keyCode value; this value 
     * is used instead.  
     */
UNDEFINED:KeyStroke = KeyStroke {id: <<java.awt.event.KeyEvent>>.VK_UNDEFINED };
