/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Accelerator;
import javafx.ui.KeyStroke;
import javafx.ui.Icon;
import javafx.ui.AbstractMenuItem;

public class MenuItem extends AbstractMenuItem {
    protected attribute jmenuitem:<<javax.swing.JMenuItem>>;
    protected operation createMenuItem():<<javax.swing.JMenuItem>>;

    public attribute mnemonic: KeyStroke?;
    public attribute accelerator: Accelerator?;
    public attribute text: String;
    public attribute icon: Icon?;
    public attribute action: function();
}

operation MenuItem.createComponent():<<javax.swing.JComponent>> {
    jmenuitem = this.createMenuItem();
    jmenuitem.setOpaque(false);
    var self = this;
    jmenuitem.addActionListener(new <<java.awt.event.ActionListener>>() {
                                    operation actionPerformed(e) {
                                        if (self.action <> null) {
                                            (self.action)();
                                        }
                                    }
                                });
    if (mnemonic <> null) {
        jmenuitem.setMnemonic(mnemonic.id);
    }
    if (icon <> null) {
        jmenuitem.setIcon(icon.getIcon());
    }
    if (accelerator <> null) {
        var mask = 0;
        for (i in accelerator.modifier) {
            mask += i.id;
        }
        jmenuitem.setAccelerator(<<javax.swing.KeyStroke>>.getKeyStroke(accelerator.keyStroke.id, mask)); 
    }
    if (text <> null) {
        jmenuitem.setText(text);
    }
    return jmenuitem;
}

operation MenuItem.createMenuItem() {
    var menuItem = new <<javax.swing.JMenuItem>>();
    menuItem.setIcon(new <<javax.swing.ImageIcon>>(context:<<net.java.javafx.ui.UIContext>>.getTransparentImage(13, 13)));
    return menuItem;
}

trigger on (MenuItem.text = value) {
    if (jmenuitem <> null) {
        jmenuitem.setText(value);
    }
}

trigger on (MenuItem.icon = value) {
    if (jmenuitem <> null) {
        jmenuitem.setIcon(value.getIcon());
    }
}

trigger on (MenuItem.mnemonic = value) {
    if (jmenuitem <> null) {
        jmenuitem.setMnemonic(value.id);
    }
}


trigger on (MenuItem.accelerator = value) {
    if (jmenuitem <> null) {
        var mask = 0;
        for (i in value.modifier) {
            mask += i.id;
        }
        jmenuitem.setAccelerator(<<javax.swing.KeyStroke>>.getKeyStroke(value.keyStroke.id, mask)); 
    }
}
