/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;
import javafx.ui.HorizontalAlignment;

public class PasswordField extends Widget {
    protected attribute inListener: Boolean;
    private attribute textField: <<javax.swing.JPasswordField>>;

    public attribute value: String;
    public attribute onChange: function(newValue:String);
    public attribute action: function();
    public attribute columns: Number;
    public attribute horizontalAlignment:HorizontalAlignment;
}

trigger on (PasswordField.horizontalAlignment = value) {
    textField.setHorizontalAlignment(value.id);
}

operation PasswordField.createComponent():<<javax.swing.JComponent>> {
    return textField;
}

trigger on (new PasswordField) {
    textField = new <<javax.swing.JPasswordField>>;
    var tf = textField;
    tf.setFont(<<javax.swing.UIManager>>.getFont("TextField.font"));
    var self = this;
    textField.getDocument().addDocumentListener(new <<javax.swing.event.DocumentListener>>() {
                                                    operation insertUpdate(e) {
                                                        self.inListener = true;
                                                        self.value = tf.getText();
                                                        self.inListener = false;
                                                        (self.onChange)(self.value);
                                                    }
                                                    operation removeUpdate(e) {
                                                        self.inListener = true;
                                                        self.value = tf.getText();
                                                        (self.onChange)(self.value);
                                                        self.inListener = false;
                                                    }
                                                    operation changedUpdate(e) {
                                                        self.inListener = true;
                                                        self.value = tf.getText();
                                                        self.inListener = false;
                                                        (self.onChange)(self.value);
                                                    }
        });
    textField.addActionListener(new <<java.awt.event.ActionListener>>() {
                                    operation actionPerformed(e) {
                                        self.value = self.textField.getText();
                                        if (self.action <> null) {
                                              (self.action)();
                                        } else {
                                              var root = tf.getRootPane();      
                                              var but = root.getDefaultButton();
                                              if (but <> null) {
                                                  (self.onChange)(tf.getText());
                                                  but.doClick(0);
                                              }
                                        }
                                    }       
                                });     
}

trigger on (PasswordField.value = x) {
    if (not inListener) {
        textField.setText(x);
    }
}

trigger on (PasswordField.columns = n) {
    textField.setColumns(n);
}
