/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.SplitPane;
import javafx.ui.Widget;
import java.lang.System;
import java.awt.Dimension;

public class SplitView {
    protected attribute splitpane: SplitPane;
    protected  attribute splitnode: <<net.java.javafx.ui.MultiSplitLayout$Leaf>>;
    public attribute weight: Number;
    protected  attribute id: String;
    public attribute content: Widget;
    protected operation getSplitNode(): <<net.java.javafx.ui.MultiSplitLayout$Node>>;
}

attribute SplitView.id = "{System.identityHashCode(this)}";

operation SplitView.getSplitNode() {
   if (splitnode == null) {
       splitnode = new <<net.java.javafx.ui.MultiSplitLayout$Leaf>>(id);
       splitnode.setWeight(weight);
   }
   return splitnode;
}

trigger on (SplitView.weight = value) {
    if (splitnode <> null) {
        splitnode.setWeight(weight);
    }
}

trigger on (SplitView.content[old] = pane) {
    pane.getComponent().setMinimumSize(new Dimension(0, 0));
     if (splitpane <> null) {
        if (old <> null) {
            splitpane.getComponent().remove(old.getComponent());
        }
        if (pane <> null) {
            splitpane.getComponent().add(pane.getComponent(), id);
        }
     }
}
