/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Border;
import javafx.ui.Table;


public class TableCell {
    protected attribute table:Table;
    public attribute text:String;
    public attribute toolTipText: String?;
    public attribute background: Color?;
    public attribute foreground: Color?;
    public attribute font: Font?;
    public attribute border: Border?;
    public attribute value:*;
    public attribute selected: Boolean;
}

trigger on (TableCell.text = newValue) {
    if (table.tableModel <> null) {
        var cr = select indexof x from x in table.cells where x == this;
        table.tableModel.updateCell(cr, text, toolTipText, font.getFont(),
                                    background.getColor(), foreground.getColor(), border.getBorder());
    }
}

trigger on (TableCell.toolTipText = newValue) {
    if (table.tableModel <> null) {
        var cr = select indexof x from x in table.cells where x == this;
        table.tableModel.updateCell(cr, text, toolTipText, font.getFont(),
                                    background.getColor(), foreground.getColor(), border.getBorder());
    }
}

trigger on (TableCell.selected = newValue) {
    if (table <> null) {
        if (newValue) {
            var cr = select indexof x from x in table.cells where x == this;
            var row = (cr / sizeof table.columns).intValue();
            table.selection = row;
        } else {
            table.selection = -1;
        }
    }
}

trigger on (TableCell.font = newValue) {
    if (table.tableModel <> null) {
        var cr = select indexof x from x in table.cells where x == this;
        table.tableModel.updateCell(cr, text, toolTipText, font.getFont(),
                                    background.getColor(), foreground.getColor(), border.getBorder());
    }
}

trigger on (TableCell.background = newValue) {
    if (table.tableModel <> null) {
        var cr = select indexof x from x in table.cells where x == this;
        table.tableModel.updateCell(cr, text, toolTipText, font.getFont(),
                                    background.getColor(), foreground.getColor(), border.getBorder());
    }
}

trigger on (TableCell.foreground = newValue) {
    if (table.tableModel <> null) {
        var cr = select indexof x from x in table.cells where x == this;
        table.tableModel.updateCell(cr, text, toolTipText, font.getFont(),
                                    background.getColor(), foreground.getColor(), border.getBorder());
    }
}
