/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.ScrollableWidget;
import javafx.ui.ContentType;

public class TextPane extends ScrollableWidget {
    private attribute inUpdate:Boolean;
    private attribute documentListener:<<javax.swing.event.DocumentListener>>;
    private attribute jtextpane: <<javax.swing.JTextPane>>;
    public attribute editable: Boolean?;
    public attribute content: **;
    public attribute contentType: ContentType;
}

trigger on (TextPane.editable = value) {
    jtextpane.setEditable(value);
}


trigger on (new TextPane) {
    jtextpane = new <<javax.swing.JTextPane>>;
    jtextpane.getDocument().putProperty("imageCache",
                                        context:<<net.java.javafx.ui.UIContext>>.getImageCache());
    editable = true;
    var self = this;
    documentListener = new <<javax.swing.event.DocumentListener>>() {
        operation insertUpdate(e:<<javax.swing.event.DocumentEvent>>) {
            self.inUpdate = true;

            self.inUpdate = false;
        }
        operation removeUpdate(e:<<javax.swing.event.DocumentEvent>>) {
            self.inUpdate = true;

            self.inUpdate = false;
        }
        operation changedUpdate(e:<<javax.swing.event.DocumentEvent>>) {
            self.inUpdate = true;

            self.inUpdate = false;
        }
    };
    jtextpane.getDocument().addDocumentListener(documentListener);
}


operation TextPane.createView():<<javax.swing.JComponent>> {
    return jtextpane;
}

trigger on (insert element into TextPane.content) {
    var off = 0;
    for (i in content) {
        if (i == element) {
            break;
        }
        if (i instanceof String) {
            off += ((String)i).length();
        } else {
            off += 1;
        }
    }
    jtextpane.<<select>>(off, off);
    if (element instanceof Widget) {
        jtextpane.insertComponent(((Widget)element).getComponent());
    } else if (element instanceof Icon) {
        jtextpane.insertIcon(((Icon)element).getIcon());
    } else {
        jtextpane.replaceSelection("{element}");
    }
}

trigger on (TextPane.content[oldValue] = newValue) {
}

trigger on (delete element from TextPane.content) {
    var off = 0;
    for (i in [0..<indexof element]) {
        var e = content[i];
        if (e instanceof String) {
            off += ((String)e).length();
        } else {
            off += 1;
        }
    }
    var endOff = off;
    if (element instanceof String) {
        endOff += ((String)element).length();
    }
    jtextpane.<<select>>(off, endOff);
    jtextpane.replaceSelection("");
}

trigger on (TextPane.contentType = value) {
    jtextpane.setContentType(value.mimeType);
}
