/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;
import javafx.ui.Insets;
import javafx.ui.Orientation;

public class ToolBar extends Widget {
    private attribute panel: <<javax.swing.JPanel>>;
    protected attribute toolbar: <<javax.swing.JToolBar>>;

    public attribute floatable: Boolean?;
    public attribute rollover: Boolean;
    public attribute borderPainted: Boolean?;
    public attribute margin: Insets?;
    public attribute orientation: Orientation;
    public attribute buttons: Widget*;
}

attribute ToolBar.opaque = true;
attribute ToolBar.orientation = HORIZONTAL:Orientation;

trigger on (ToolBar.margin = value) {
    toolbar.setMargin(value.awtinsets);
}

trigger on (ToolBar.orientation = value) {
    if ( orientation == HORIZONTAL:Orientation) {
	toolbar.setOrientation(<<javax.swing.JToolBar>>.HORIZONTAL);	
    } else {
	toolbar.setOrientation(<<javax.swing.JToolBar>>.VERTICAL);
    }
}

trigger on (ToolBar.floatable = value) {
    if (value <> null) {
        toolbar.setFloatable(value);
    }
}

trigger on (ToolBar.borderPainted = value) {
    if (value <> null) {
        toolbar.setBorderPainted(value);
    }
}

trigger on (insert button into ToolBar.buttons) {
    if (button.focusable == null) {
        button.focusable = false;
    }
    toolbar.add(button.getComponent(), indexof button);
}

trigger on (delete button from ToolBar.buttons) {
    toolbar.remove(indexof button);
}

operation ToolBar.createComponent():<<javax.swing.JComponent>> {
    return panel;
}

trigger on (new ToolBar) {
    rollover = true;
    panel = new <<javax.swing.JPanel>>;
    panel.setLayout(new <<java.awt.FlowLayout>>(<<java.awt.FlowLayout>>.LEADING, 0, 0));
    panel.setBorder(null);
    panel.setOpaque(true);
    if (orientation == HORIZONTAL:Orientation) {	
	toolbar = new <<javax.swing.JToolBar>>(<<javax.swing.JToolBar>>.HORIZONTAL);
    } else {
	toolbar = new <<javax.swing.JToolBar>>(<<javax.swing.JToolBar>>.VERTICAL);
    }
    toolbar.setOpaque(false);
    toolbar.setFloatable(false);
    panel.add(toolbar);
}

trigger on (ToolBar.rollover = value) {
    toolbar.setRollover(value);
}
