/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Shape;
import javafx.ui.canvas.ArcClosure;
import net.java.javafx.jazz.component.ZArc;

public class Arc extends Shape {
    private attribute zarc: ZArc;
    public attribute x: Number;
    public attribute y: Number;
    public attribute width: Number;
    public attribute height: Number;
    public attribute startAngle: Number;
    public attribute length: Number;
    public attribute closure: ArcClosure;
}

attribute Arc.closure = OPEN:ArcClosure;

trigger on Arc.x = value {
    zarc.setArc(x, y, width, height, startAngle, length, closure.id);
}

trigger on Arc.y = value {
    zarc.setArc(x, y, width, height, startAngle, length, closure.id);
}

trigger on Arc.width = value {
    zarc.setArc(x, y, width, height, startAngle, length, closure.id);
}

trigger on Arc.height = value {
    zarc.setArc(x, y, width, height, startAngle, length, closure.id);
}

trigger on Arc.startAngle = value {
    zarc.setArc(x, y, width, height, startAngle, length, closure.id);
}

trigger on Arc.length = value {
    zarc.setArc(x, y, width, height, startAngle, length, closure.id);
}

trigger on Arc.closure = value {
    zarc.setArc(x, y, width, height, startAngle, length, closure.id);
}

operation Arc.createShape() {
    zarc = new ZArc(x, y, width, height, startAngle, length, closure.id);
    return zarc;
}
