/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.Canvas;
import javafx.ui.Image;
import net.java.javafx.ui.UIContext;
import javax.swing.Icon as SwingIcon;

public class CanvasImage extends Image {
    private attribute canvasIcon: SwingIcon?; 
    private attribute canvas: Canvas;
    private attribute imageUrl: String?;
    public attribute content: Node;
}

attribute CanvasImage.imageUrl = bind url;

trigger on CanvasImage.imageUrl = value {
    if (image == null) {
        do later {
            this.getImage();
        }
    } else {
        context:UIContext.defineImage(value, image);
    }
}

trigger on CanvasImage.content = value {
    if (canvas <> null) {
        canvas.content = value;
    }
}

operation CanvasImage.getImage() {
    if (canvas == null) {
        canvas = Canvas { content: this.content };
    }
    if (canvasIcon <> canvas.zcanvas.toIcon()) {
        canvas.getComponent();
        canvasIcon = canvas.zcanvas.toIcon();
        image = canvas.zcanvas.getIconImage();        
        if (url <> null) {
            context:UIContext.defineImage(url, image);
        }
    }
    return image;
}
