/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.PathElement;
import java.awt.geom.GeneralPath;

/**
 * Closes the current subpath by drawing a straight line back to
 * the coordinates of the last <code>MoveTo</code>.  If the path is already
 * closed then it has no effect.
 */
public class ClosePath extends PathElement {
}

operation ClosePath.addTo(gp:GeneralPath) {
	var currentPoint = gp.getCurrentPoint();
	path.currentX = currentPoint.x;
	path.currentY = currentPoint.y;

    //gp.lineTo(path.lastMoveToX, path.lastMoveToY);
    gp.closePath();
}
