/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
//import javafx.ui.canvas.Node;
import net.java.javafx.jazz.ZGroup;

/**
 * Abstract base class for user-defined Node's. You can create your
 * own node classes by extending this class and implementing its
 * <code>composeNode()</code> method.
 */

public class CompositeNode extends Node {

    private attribute __composite__: Node;

    /** Abstract method which returns the content of this user-defined node */
    protected operation composeNode(): Node;
    ...
}


operation CompositeNode.createNode() {
    __composite__ = this.composeNode();
    __composite__.parentCanvasElement = this;
    var n = __composite__.getNode();
    if (n == null) {
        throw "CompositeNode class {this.class.Name} returned null from composeNode()";
    }
    var tg = new ZGroup();
    tg.addChild(n);
    //tg.putClientProperty("f3", this);
    return tg;
}
