/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Layout;
import net.java.javafx.jazz.ZGridManager;
import net.java.javafx.jazz.ZLayoutGroup;
import javafx.ui.XY;

class GridLayout extends Layout {
    attribute layoutmgr: ZGridManager;
    attribute rows: Number;
    attribute cols: Number;
    attribute width: Number;
    attribute height: Number;
    attribute hgap: Number;
    attribute vgap: Number;
    attribute startpoint: XY;
}

attribute GridLayout.rows = 1;
attribute GridLayout.cols = 0;
attribute GridLayout.hgap = 0.0;
attribute GridLayout.vgap = 0.0;
attribute GridLayout.width = 50;
attribute GridLayout.height = 50;
attribute GridLayout.startpoint = XY { x: 0.0, y: 0.0 };

operation GridLayout.createNode() {
    layoutgroup = new ZLayoutGroup();
    layoutmgr = new ZGridManager(rows, cols, width, height, hgap, vgap, startpoint.x, startpoint.y);
    layoutgroup.setLayoutManager(layoutmgr);
    for (i in content) {
	layoutgroup.addChild(i.getNode());
    }
    return layoutgroup;
}

trigger on GridLayout.rows = value {
    if (layoutmgr <> null) {
	layoutmgr.setRows(rows);
	layoutgroup.invalidate();
    }
}

trigger on GridLayout.cols = value {
    if (layoutmgr <> null) {
	layoutmgr.setColumns(cols);
	layoutgroup.invalidate();
    }
}

trigger on GridLayout.width = value {
    if (layoutmgr <> null) {
	layoutmgr.setWidth(width);
	layoutgroup.invalidate();
    }
}

trigger on GridLayout.height = value {
    if (layoutmgr <> null) {
	layoutmgr.setHeight(height);
	layoutgroup.invalidate();
    }
}

trigger on GridLayout.hgap = value {
    if (layoutmgr <> null) {
	layoutmgr.setHgap(hgap);
	layoutgroup.invalidate();
    }
}

trigger on GridLayout.vgap = value {
    if (layoutmgr <> null) {
	layoutmgr.setVgap(vgap);
	layoutgroup.invalidate();
    }
}

trigger on GridLayout.startpoint = value {
    if (layoutmgr <> null) {
	layoutmgr.setLayoutStartPoint(startpoint.x, startpoint.y);
	layoutgroup.invalidate();
    }
}
