/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Shape;
import net.java.javafx.jazz.component.ZLine;

/**
 * Creates a line between the points <code>(x1,&nbsp;y1)</code> 
 * and <code>(x2,&nbsp;y2)</code>.
 */


public class Line extends Shape {
    private attribute zline: ZLine;
    /** the first point's <i>x</i> coordinate. */
    public attribute x1: Number;
    /** the first point's <i>y</i> coordinate. */
    public attribute y1: Number;
    /** the second point's <i>x</i> coordinate. */
    public attribute x2: Number;
    /** the second point's <i>y</i> coordinate. */
    public attribute y2: Number;
 
//    operation setLine(x1:Number, y1: Number, x2: Number, y2: Number);
}

operation Line.createShape() {
    zline = new ZLine(x1, y1, x2, y2);
    return zline;
}

trigger on Line.x1 = value {
    zline.setLine(x1, y1, x2, y2);
}

trigger on Line.y1 = value {
    zline.setLine(x1, y1, x2, y2);
}

trigger on Line.x2 = value {
    zline.setLine(x1, y1, x2, y2);
}

trigger on Line.y2 = value {
    zline.setLine(x1, y1, x2, y2);
}
/*
operation Line.setLine(x1:Number, y1:Number, x2:Number, y2:Number) {
    zline.setLine(x1, y1, x2, y2);
    this.x1 = x1;
    this.x2 = x2;
    this.y1 = y1;
    this.y2 = y2;
}
*/
