/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import java.awt.geom.AffineTransform;
import java.lang.Math;
/**
 * Transformation operation which moves an object.  
 */

public class Translate extends Transform {
    /** The distance to move this object along the x axis */
    public attribute x: Number;
    /** The distance to move this object along the y axis */
    public attribute y: Number;
}

trigger on Translate.x[old] = value {
    transform = AffineTransform.getTranslateInstance(x, y);
}

trigger on Translate.y[old] = value {
   transform = AffineTransform.getTranslateInstance(x, y);
}

translate:Translate = function(x:Number, y:Number) {
   return Translate {x: bind x, y: bind y};
};


translateX:Translate = operation(x:Number) {
   return Translate {x: x, y: 0};
};

translateY:Translate = function(y:Number) {
   return Translate {x: 0, y: bind y};
};


