package javafx.ui.canvas;
import javafx.ui.canvas.Shape;
import java.awt.geom.Area as JArea;
import java.awt.geom.Rectangle2D$Double as Rectangle2D;
import net.java.javafx.jazz.component.ZShape;

public class Union extends Shape {
    public attribute content: Shape*;
    operation getArea();
}

operation Union.createShape() {
    zshape = new ZShape();
    this.getArea();
    return zshape;
}

trigger on insert c into Union.content {
    this.getArea();
}

trigger on delete c from Union.content {
    this.getArea();
}

trigger on Union.content[oldValue] = newValue {
    this.getArea();
}

operation Union.getArea() {
    if (zshape <> null) {
        if (sizeof content == 1) {
   	   zshape.setShape(content[0].getTransformedShape());
        } else if (sizeof content > 1) {
            var area = new JArea(content[0].getTransformedShape());
            for (c in content) {
                if (indexof c > 0) {
                    var s1 = c.getTransformedShape();
                    area.add(new JArea(s1));
                }
            }
            zshape.setShape(area);
        }
    }
}

