/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.filter;
import javafx.ui.filter.ConvolveFilter;
import com.jhlabs.image.GaussianFilter as JHGaussianFilter;

// GaussianBlur

public class GaussianBlur extends ConvolveFilter {
    protected attribute gaussianFilter: JHGaussianFilter;

    public attribute radius: Number;
}

operation GaussianBlur.createConvolveFilter() {
    gaussianFilter = new JHGaussianFilter(radius);
    return gaussianFilter;
}

attribute GaussianBlur.radius = 2;

trigger on GaussianBlur.radius = value {
    gaussianFilter.setRadius(radius);
}
