/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.filter;
import javafx.ui.filter.Filter;
import javafx.ui.Image;
import <<com.jhlabs.image.LightFilter>> as JHLightFilter;
import java.awt.Color;

public class LightFilter extends Filter {
    private attribute lightFilter: JHLightFilter;
    public attribute environmentMap: Image?;
    public attribute viewDistance: Number;
    public attribute bumpHeight: Number;
    public attribute bumpSoftness: Number;
    public attribute diffuseColor: Color?;
    public attribute specularColor: Color?;
    public attribute diffuseReflectivity: Number;
    public attribute specularReflectivity: Number;
    public attribute ambientIntensity: Number;
    public attribute highlight: Number;
    public attribute reflectivity: Number;
    public attribute light: Light*;
    protected operation createLightFilter(): JHLightFilter;
}

operation LightFilter.createLightFilter() {
    return new JHLightFilter();
}

operation LightFilter.createFilter() {
    if (lightFilter == null) {
        lightFilter = this.createLightFilter();
        for (i in light) {
            lightFilter.addLight(i.getLight());
        }
        lightFilter.setBumpSoftness(bumpSoftness);
        lightFilter.setBumpHeight(bumpHeight);
        lightFilter.setViewDistance(viewDistance);
        if (environmentMap <> null) {
            //lightFilter.setEnvironmentMap(environmentMap.getImage());
        }
        if (diffuseColor <> null) {
            lightFilter.setDiffuseColor(diffuseColor.getRGB());
            lightFilter.setColorSource(lightFilter.COLORS_CONSTANT);
            if (specularColor == null) {
                specularColor = Color.white;
            }
        }
        if (specularColor <> null) {
            if (diffuseColor == null) {
                diffuseColor = new Color(0x88, 0x88, 0x77);
                lightFilter.setDiffuseColor(diffuseColor.getRGB());
            }
            lightFilter.setSpecularColor(specularColor.getRGB());
            lightFilter.setColorSource(lightFilter.COLORS_CONSTANT);
        }
        lightFilter.setDiffuseReflectivity(diffuseReflectivity);
        lightFilter.setSpecularReflectivity(specularReflectivity);
        lightFilter.setHighlight(highlight);
        lightFilter.setReflectivity(reflectivity);
    }
    return lightFilter;
}

//attribute LightFilter.diffuseColor = rgb(0x88,0x88,0x88);
//attribute LightFilter.specularColor = white;
attribute LightFilter.bumpSoftness = 5.0;
attribute LightFilter.bumpHeight = 1.0;
attribute LightFilter.viewDistance = 10000.0;
attribute LightFilter.diffuseReflectivity = 1.0;
attribute LightFilter.specularReflectivity = 1.0;
attribute LightFilter.highlight = 3.0;
attribute LightFilter.reflectivity = 0.0;
