/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.filter;
import javafx.ui.*;
import net.java.javafx.ui.OpacityMaskFilter as JOpacityMaskFilter;
import java.awt.Paint as AWTPaint;
import javafx.ui.Paint;

public class OpacityMask extends Filter {
    private attribute awtFill: AWTPaint?;
    private attribute opacityMaskFilter: JOpacityMaskFilter;
    public attribute fill: Paint;
}

attribute OpacityMask.awtFill = bind fill.getPaint();

trigger on OpacityMask.awtFill = newValue {
    opacityMaskFilter.setOpacityMask(newValue);
}

operation OpacityMask.createFilter() {
    opacityMaskFilter = new JOpacityMaskFilter();
    opacityMaskFilter.setOpacityMask(awtFill);
    return opacityMaskFilter;
}
