/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.filter;
import javafx.ui.filter.Filter;
import javafx.ui.filter.ShapeBurstType;
import com.jhlabs.image.ShapeFilter as JHShapeFilter;

// ShapeBurst 

public class ShapeBurst extends Filter {
    protected attribute shapeFilter: JHShapeFilter;
    public attribute factor: Number;
    public attribute useAlpha: Boolean;
    public attribute type: ShapeBurstType;
    public attribute invert: Boolean;
    public attribute merge: Boolean;
}

attribute ShapeBurst.factor = 1.0;
attribute ShapeBurst.useAlpha = true;
attribute ShapeBurst.invert = false;
attribute ShapeBurst.merge = false;
attribute ShapeBurst.type = LINEAR:ShapeBurstType;

operation ShapeBurst.createFilter() {
    if (shapeFilter == null) {
        shapeFilter = new JHShapeFilter();
        shapeFilter.setFactor(factor);
        shapeFilter.setUseAlpha(useAlpha);
        shapeFilter.setInvert(invert);
        shapeFilter.setMerge(merge);
        shapeFilter.setType(type.id);
    }
    return shapeFilter;
}

